<?php

namespace App\Policies;

use App\Models\Academic;
use App\Models\User;
use Illuminate\Auth\Access\Response;

class AcademicPolicy
{
    /**
     * Determine whether the user can view any models.
     */
    public function viewAny(User $user): bool
    {
        return $user->hasAnyPermission([
            'create academic', 'edit academic', 'view academic', 'delete academic'
        ]);
    }

    /**
     * Determine whether the user can view the model.
     */
    public function view(User $user, Academic $academic): bool
    {
        return $user->hasPermissionTo('view academic');
    }

    /**
     * Determine whether the user can create models.
     */
    public function create(User $user): bool
    {
        return $user->hasPermissionTo('create academic');
    }

    /**
     * Determine whether the user can update the model.
     */
    public function update(User $user, Academic $academic): bool
    {
        return $user->hasPermissionTo('edit academic');
    }

    /**
     * Determine whether the user can delete the model.
     */
    public function delete(User $user, Academic $academic): bool
    {
        return $user->hasPermissionTo('delete academic');
    }

    /**
     * Determine whether the user can restore the model.
     */
    public function restore(User $user, Academic $academic): bool
    {
        return $user->hasPermissionTo('restore academic');
    }

    /**
     * Determine whether the user can permanently delete the model.
     */
    public function forceDelete(User $user, Academic $academic): bool
    {
        return $user->hasPermissionTo('force delete academic');
    }
}
